function trace() {
    return;
    var str = new Date().getTime()+' - '+arguments[0];
    var len = arguments.length;
    for (var i = 1; i < len; i++) {
        str += "," + arguments[i];
    }
    $('#debugMsg').append($('<p>'+str+'</p>'));
    console.log(str);
}

function clearTrace() {
    $('#debugMsg').html('<p><a href="javascript:clearTrace()">Clear Trace</a></p>');
}
$(function() {
    if (window.PIE) {
        $('.vm_border').each(function() {
            PIE.attach(this);
        });
        $('.vm_volume').each(function() {
            PIE.attach(this);
        });
        $('.vm_process').each(function() {
            PIE.attach(this);
        });
        $('.vm_slider_loading').each(function() {
            PIE.attach(this);
        });
        $('.vm_slider_current').each(function() {
            PIE.attach(this);
        });
        $('.vm_slider_barknoll').each(function() {
            PIE.attach(this);
        });
        $('.vm_videoInfo').each(function() {
            PIE.attach(this);
        });
        $('.vm_slideInfo').each(function() {
            PIE.attach(this);
        });
    }
    $.isFramed = (window.location != window.parent.location);
    $.useFakeFullScreen = false;
    
    var isAndroid = false;
    var is_chrome = false;
    var ua = navigator.userAgent.toLowerCase();
    isAndroid = (ua.indexOf("android") > -1);
    is_chrome = (Boolean(window.chrome) && !isAndroid)
    
    try {
        document.createEvent("TouchEvent");
        $.isTouchDevice = true;
	if (is_chrome) {
	    $.isTouchDevice = false;
	}
    } catch(error) {
        $.isTouchDevice = false;
    }
    if ($.isTouchDevice) {
        $.clickEvent = 'touchend';
        $(window).on('touchmove', function(evt) {
            evt.preventDefault();
        });
    } else {
        $.clickEvent = 'click';
    }
    var vmBorder = $('.vm_border');
    var borderBottomWidth = vmBorder.cssNo('border-bottom-width') + vmBorder.cssNo('border-top-width');
    var borderLeftWidth = vmBorder.cssNo('border-left-width') + vmBorder.cssNo('border-right-width');
    
    var stageHOffset = 27;
    var url = location.search;
    var hash = url.substring(1);
    var hashA = hash.split("&");
    var hashLen = hashA.length;
    var waitExternalFileCount = 0;
    var waitExternalFileA = [];
    $.isIOS = false;
    $.isMobile = false;
    $.isHLS = false;
    var readyInit = function() {
        if (waitExternalFileCount==0) {
	        if ($('.vcamso_presentation_player').length == 1) {
	            new VCASMOPlayer($('.vcamso_presentation_player'), hash);
	        } else {
	            $('.vcamso_presentation_player').each(function() {
	                new VCASMOPlayer($(this), false);
	            });
	        }
        }
    } 
    var extFileLoaded = function() {
    	waitExternalFileCount--;
    	if (waitExternalFileCount==0) {
    		setTimeout(readyInit, 500);
    	}
    }
    for (var i = 0; i < hashLen; i++) {
        var _vo = hashA[i].split("=");
        var _voLabel = _vo[0];
        if (_voLabel=='configfile') {
            borderLeftWidth = 0;
            borderBottomWidth = 0;
            stageHOffset = 0;
	    	var _jscssfilename = _vo[1];
	    	if (_jscssfilename.indexOf('.xml')>0) {
				_jscssfilename = _jscssfilename.substring(0, _jscssfilename.indexOf('.xml'));
	    	}
	    	waitExternalFileA.push(_jscssfilename+'.js');
           	waitExternalFileA.push(_jscssfilename+'.css');
        } else if (_voLabel=='otherjs') {
        	waitExternalFileA.push(_vo[1]);
        } else if (_voLabel=='othercss') {
        	waitExternalFileA.push(_vo[1]);
        }
    }
    waitExternalFileCount = waitExternalFileA.length;
    var stageResize = function() {
        var stageW = $(window).width();
        var stageH = $(window).height() - borderBottomWidth;
        var dualH = stageH + stageHOffset;
        $('.vcamso_presentation_player').height(stageH);
        $('.vcamso_presentation_player .vm_dualscreen').width(stageW - borderLeftWidth);
        $('.vcamso_presentation_player .vm_dualscreen').height(dualH);
    }
    $(window).resize(function() {
        stageResize();
    });
    stageResize();
    //var mobile_timer = false;
    if (navigator.userAgent.match(/iP(hone|od|ad)/i)) {
    	$.isIOS = true;
        $(window).on('orientationchange', function() {
            /*clearTimeout(mobile_timer);
             $('#viewport').attr('content','width=device-width,initial-scale=1,minimum-scale=1,maximum-scale=1');
             mobile_timer = setTimeout(function () {
             $('#viewport').attr('content','width=device-width,initial-scale=1,minimum-scale=1,maximum-scale=10');
             },1000);*/
            if (!$.isFramed) {
                $(window).scrollLeft(0);
                $(window).scrollTop(0);
            }
        });
    }
    $(document).ready(function() {
    	if (jQuery.browser.mobile) {
    		$.isMobile = true;
            $('.vcamso_presentation_player .vm_volume').hide();
        }
        readyInit();
    });
    var ranStr = ($.isIOS) ? '?t='+new Date().getTime() : '';
    for (var i=0;i<waitExternalFileCount;i++) {
    	$.get(waitExternalFileA[i]+ranStr, function(data, status){
    		if (status=='success') {
	    		if (this.url.lastIndexOf('.css')>0) {
					$('head').append('<link rel="stylesheet" href="'+this.url+'" type="text/css" />');
				} else if (this.url.lastIndexOf('.js')>0) {
	    			// jQuery will auto executed script file when loaded, no need append
	    		}  
				extFileLoaded();
			}
		})
	}    
});
$.fn.cssNo = function(prop){
    var v = parseInt(this.css(prop),10);
    return isNaN(v) ? 0 : v;
};
// put it in global instead of jquery local for 3rd party to use it
function VCASMOPlayer(_mc, hash, isMultiple) {
    var self = this;
    this.speakerListXML = '';
    this.duration_total = 0;
    this.tmp_slide_current = 0;
    this.slide_current = 0;
    this.slide_total = 0;
    this.emailSubject = '';
    this.emailContent = '';
    this.emailLink = ''
    this.directURL = 'https://www.vcasmo.com/';
    this.assetPath = '';
    this.videoPath = '';
    this.videoCDNPath = '';
    this.logoPath = 'https://asset.vcasmo.com/';
    this.inPortal = 1;
    this.slideObj = {};
    
    this.bothVideoSlide = 0;
    // 0 = unknown, 1 = video only, 2 = audio only, 3 = audio + slide, 4 = slide only, 5 = video + slide

    this.dualScreenControllerKeptBtn = [];
    this.videoControllerKeptBtn = [];
    this.slideControllerKeptBtn = [];
    this.indicator = 'images/indicator_bk.gif';
    this.isAutoPlay = false;
    this.mc = _mc;
    
    this.defaultSlideW = 640;
    this.defaultSlideH = 480
    
    // for video
    this.videoBarknoll = null;
    this.isBuffering = false;
    this.isMetaDataReady = false;
    this.currentTimeBar = null;
    this.currentTime = null;
    this.curNSTime = 0;
    this.loadBar = null;
    this.media = null;
    this.isPlaying = false;
    this.streamIsStop = false;
    this.shouldPlayAfterSeek = false;
    this.videoonright = 0;
    
    // for subtitle / category
    this.subtitleA = [];
    this.subtitleALen = 0;
    this.subtitleText = null;
    this.curSubtitleId = -1;
    this.cateScroll = null;
    this.lastCateScrollPos = 0;
    this.maxCateScrollRange = 0;
        
    // for slide
    this.traneffect = '';
    this.loadedSlideCount = 0;
    this.loadSlideTimeOutId = 0;
    this.cuePointA = [];
    this.cuePointALen = -1;
    this.timer = null;
    this.timeCount = 0;
    this.slideLinkA = [];
    
    // for thumbnail
    this.isResized = false;
    this.isThumbScrollInited = false;
    this.thumbScroll = null;
    this.isThumbScrollVertical = true;
    this.lastThumbScrollPos = 0;
    this.maxThumbScrollRange = 0;
    this.thumbUnitSize = 0;
    
    // for iframe fullscreen
    this.divName = 'vm_embed_div';
    this.iframeName = 'vm_embed_iframe';

    this.vo = {
        dataPath : '',
        subtitleidStr : '',
        vcasmo_full : '',
        logoType : ''
    };
    if (!hash) {
        hash = this.mc.attr('hash');
    }
    if (hash) {
        var hashA = hash.split("&");
        var hashLen = hashA.length;
        for (var i = 0; i < hashLen; i++) {
            var _vo = hashA[i].split("=");
            this.vo[_vo[0]] = _vo[1];
        }
        if (this.vo.logoType) {
            if (isNaN(this.vo.logoType)) {
                this.vo.logoType = '';
            } else if (this.vo.logoType > 3 || this.vo.logoType < 1) {
                this.vo.logoType = '';
            }
        }
        if (!this.vo.dataPath) {
            this.vo.dataPath = "../" + this.vo.userid + "/p" + this.vo.pid + this.vo.subtitleidStr + "_data.xml";
        } else {
            this.vo.dataPath = unescape(this.vo.dataPath);
        }
    }

    if (this.vo.extjs==1) {
        this.windowProxy = new Porthole.WindowProxy();
    }
    
    if (!this.vo.vcasmo_full) {
        // dual screen
        this.layoutReset = this.layoutReset0;
        this.layoutLiquidize = this.layoutLiquidize0;
        this.videoSlideLiquidize = this.videoSlideLiquidize0;
        this.netStreamOnMetaData = this.netStreamOnMetaData0;
        $('.vm_videoInfo', this.mc).hide();
        $('.vm_slideInfo', this.mc).hide();
        if (this.vo.noborder==1) {
        	$('.vm_border', this.mc).hide();
        }
        if (this.vo.nocontrols==1) {
        	$('.vm_dualController', this.mc).hide();
        }
    } else {
        // custom layout
        this.layoutReset = this.layoutReset1;
        this.layoutLiquidize = this.layoutLiquidize1;
        this.videoSlideLiquidize = this.videoSlideLiquidize1;
        this.netStreamOnMetaData = this.netStreamOnMetaData1;
        $('.vm_dualController, .vm_dualscreen_thumbnail, .vm_border_bg', this.mc).hide();
        if (this.vo.vcasmo_full == '_pwdprotect' && this.vo.isFull != 1) {
            $('.vm_videoInfo, .vm_slideInfo', this.mc).hide();
            $('.vm_dualController', this.mc).show();
        }
        if (this.vo.showsubtitle=='0') {
        	$('.vm_subtitle', this.mc).hide();
        }
        if (this.vo.nocontrols==1) {
        	$('.vm_videoInfo', this.mc).hide();
        }
        if (this.vo.videobgcolor) {
	        $('.vm_video_holder').css('background-color', '#' + this.vo.videobgcolor);
	    }
        if (this.vo.slidebgcolor) {
	        $('.vm_slide_holder').css('background-color', '#' + this.vo.slidebgcolor);
	    }
        if (this.vo.thumbnailbgcolor) {
	        $('.vm_thumbnail_panel').css('background-color', '#' + this.vo.thumbnailbgcolor);
	    }
    }
    if (!this.vo.subtitleidStr) {
        $('.vm_subtitle', this.mc).hide();
    }
    if (this.vo.nomail == 1) {
        $('.vm_btn_email', this.mc).hide();
    } else {
        $('.vm_btn_email', this.mc).on($.clickEvent, function() {
            self.emailFriend();
        });
    }
    
    if ($.support.fullscreen) {
        $('.vm_btn_enlarge', this.mc).on($.clickEvent, function() {
            $(self.mc).fullScreen({
                callback : function(bool) {
                    self.onFullScreen(bool);
                }
            });
        });
        $('.vm_btn_shrink', this.mc).on($.clickEvent, function() {
            $(self.mc).fullScreen({
                callback : function(bool) {
                    self.onFullScreen(bool);
                }
            });
            
            // BUG: fix iframed, chrome cannot return full screen to normal screen event.
            // BUG: if user click "Escape", bug still exist 
            self.onFullScreen(false);
        });
    } else {
        if (!$.isFramed) {
            if (this.vo.asTopFS==1) {
            	this.vo.swfbgcolor = false;
                this.onFullScreen(true);
                $('.vm_btn_shrink', this.mc).on($.clickEvent, function() {
                    if (self.vo.referrer) {
                        window.location = unescape(self.vo.referrer);
                    } else {
                        window.location = document.referrer;
                    }
                });
            } else {
                $('.vm_btn_fullscreen', this.mc).hide();
            }
        } else {
            try {
                // same domain
                if (this.vo.divName) {
                    this.divName = this.vo.divName;
                }
                if (this.vo.iframeName) {
                    this.iframeName = this.vo.iframeName;
                }
                top.vcasmoAllowFullScreen(this.divName, this.iframeName, $.isMobile);
                $('.vm_btn_enlarge', this.mc).on($.clickEvent, function() {
                    top.vcasmo_fullScreen(false);
                    self.onFullScreen(true);
                });
                $('.vm_btn_shrink', this.mc).on($.clickEvent, function() {
                    top.vcasmo_normalScreen();
                    self.onFullScreen(false);
                });
                if ($.isMobile) {
                    if ($.isFramed) {
                        $(top.window).on('orientationchange', function() {
                            if ($.useFakeFullScreen) {
                                top.vcasmo_fullScreen(true);
                            }
                        });
                    }
                }
                if ($.isFramed) {
                    $(top.window).on('resize', function() {
                        if ($.useFakeFullScreen) {
                            top.vcasmo_fullScreen(true);
                        }
                    });
                }
                $.useFakeFullScreen = true;
            } catch (error) {
                // cross domain
                $('.vm_btn_enlarge', this.mc).on($.clickEvent, function() {
                    top.location = window.location+"&asTopFS=1"+((self.vo.referrer)?'':'&referrer='+escape(document.referrer));
                });
            }
        }
    }
    if (this.vo.dataPath) {
        this.loadSpeakerPpt(this.vo.dataPath);
    } else {
        this.onLoadSpeakerPptFail();
    }
    if (this.vo.swfbgcolor) {
        $('body').css('background-color', '#' + this.vo.swfbgcolor);
    }
    if (this.vo.videobgcolor) {
        $('.vm_border_bg').css('background-color', '#' + this.vo.videobgcolor);
    }
    $(window).on('resize', function() {
        self.isResized = true;
        self.layoutReset();
        if (!self.vo.vcasmo_full) {
            // for standard dualscreen
            self.layoutLiquidize();
            self.videoSlideLiquidize();
        } else {
            // for customized layout
            self.videoSlideLiquidize();
            self.layoutLiquidize();
        }
        self.resizeScroller();
    });
    this.dispatchEvent('vcasmoSWFLoaded');
}

VCASMOPlayer.prototype.layoutReset0 = function() {
    // for standard dualscreen
    var self = this;
    $('.vm_dualController', this.mc).children().each(function(index) {
        if (!$(this).hasClass('clear')) {
            if (self.dualScreenControllerKeptBtn[index]) {
                $(this).show();
            } else {
                $(this).hide();
            }
        }
    });
}
VCASMOPlayer.prototype.layoutReset1 = function() {
    // for customized layout
    var self = this;
    $('.vm_videoInfo', this.mc).children().each(function(index) {
        if (!$(this).hasClass('clear')) {
            if (self.videoControllerKeptBtn[index]) {
                $(this).show();
            } else {
                $(this).hide();
            }
        }
    });
    $('.vm_slideInfo', this.mc).children().each(function(index) {
        if (!$(this).hasClass('clear')) {
            if (self.slideControllerKeptBtn[index]) {
                $(this).show();
            } else {
                $(this).hide();
            }
        }
    });
}
VCASMOPlayer.prototype.layoutLiquidize0 = function() {
    // for standard dualscreen
    var ds = $('.vm_dualscreen', this.mc);
    var dcc = $('.vm_dualController', this.mc).children();
    var dsw = ds.width();
    var process = $('.vm_dualController .vm_process', this.mc);
    var sw = 0;
    dcc.each(function() {
        if ($(this).css('display') != 'none' && !$(this).hasClass('vm_process') && !$(this).hasClass('clear')) {
            sw += $(this).width() + $(this).cssNo('margin-right') + $(this).cssNo('margin-left');
        }
    });
    var pw = dsw - sw - process.cssNo('margin-right') - process.cssNo('margin-left');
    if (pw >= 100) {
        this.setProcessWidth(pw);
    } else {
        var minpriority = 99;
        var minIndex = -1;
        dcc.each(function(index) {
            if ($(this).css('display') != 'none' && !$(this).hasClass('vm_process') && !$(this).hasClass('clear')) {
                var priority = $(this).attr('priority');
                if (priority) {
                    if (priority < minpriority) {
                        minpriority = priority;
                        minIndex = index;
                    }
                }
            }
        });
        if (minIndex >= 0) {
            dcc.eq(minIndex).hide();
            this.layoutLiquidize();
        } else {
            this.setProcessWidth(pw);
        }
    }
}
VCASMOPlayer.prototype.layoutLiquidize1 = function() {
	this.layoutLiquidize1_video();
	this.layoutLiquidize1_slide();
	if (this.subtitleALen>0) {
		this.cateScroll.refresh();
		this.cateMoveToLastPosition(0);
		var cat_holder = $('.vm_category_holder', this.mc);
		this.maxCateScrollRange = Math.max(0, cat_holder.height()-cat_holder.parent().height());
	}
}
VCASMOPlayer.prototype.layoutLiquidize1_video = function() {
    // NOTE: customized layout should override this with own implementation
    // for customized layout video
    var video_holder = (this.bothVideoSlide != 3 && this.bothVideoSlide != 4) ? $('.vm_video_holder', this.mc) : $('.vm_slide_holder_bg', this.mc);
    var vi = $('.vm_videoInfo', this.mc);
    var dsw = video_holder.width()-vi.cssNo('padding-left')-vi.cssNo('padding-right')-vi.cssNo('border-left-width')-vi.cssNo('border-right-width');
    var vic = vi.children();
    var process = $('.vm_videoInfo .vm_process', this.mc);
    var sw = 0;
    vic.each(function() {
        if ($(this).css('display') != 'none' && !$(this).hasClass('vm_process') && !$(this).hasClass('clear')) {
            sw += $(this).width() + $(this).cssNo('margin-right') + $(this).cssNo('margin-left');
        }
    });
    var pw = dsw - sw - process.cssNo('margin-right') - process.cssNo('margin-left');
    if (pw >= 100) {
        this.setProcessWidth(pw);
    } else {
        var minpriority = 99;
        var minIndex = -1;
        vic.each(function(index) {
            if ($(this).css('display') != 'none' && !$(this).hasClass('vm_process') && !$(this).hasClass('clear')) {
                var priority = $(this).attr('priority');
                if (priority) {
                    if (priority < minpriority) {
                        minpriority = priority;
                        minIndex = index;
                    }
                }
            }
        });
        if (minIndex >= 0) {
            vic.eq(minIndex).hide();
            this.layoutLiquidize1_video();
        } else {
            this.setProcessWidth(pw);
        }
    } 
}
VCASMOPlayer.prototype.layoutLiquidize1_slide = function() {
    // NOTE: customized layout should override this with own implementation
    // for customized layout slide
    var slide_holder = $('.vm_slide_holder', this.mc);
    var si = $('.vm_slideInfo', this.mc)
    var dsw = slide_holder.width();
    var sic = si.children();
    var sw = 0;
    sic.each(function() {
        if ($(this).css('display') != 'none' && !$(this).hasClass('clear')) {
            sw += $(this).width() + $(this).cssNo('margin-right') + $(this).cssNo('margin-left');
        }
    });
	var minpriority = 99;
	var minIndex = -1;
	sic.each(function(index) {
	    if ($(this).css('display') != 'none' && !$(this).hasClass('clear')) {
	        var priority = $(this).attr('priority');
	        if (priority) {
	            if (priority < minpriority) {
	                minpriority = priority;
	                minIndex = index;
	            }
	        }
	    }
	});
	if (sw>dsw) {
		if (minIndex >= 0) {
			sic.eq(minIndex).hide();
			this.layoutLiquidize1_slide();
		}
	}
}
VCASMOPlayer.prototype.videoSlideLiquidize0 = function() {
    // for standard dualscreen
    var self = this;
    var video = $('.vm_video', this.mc);
    var slide = $('.vm_slide', this.mc);

    var ds = $('.vm_dualscreen', this.mc);
    var dsw = ds.width();
    var dsh = ds.height();
    if (this.bothVideoSlide == 5) {
        var mcw = this.mc.width();
        var mch = this.mc.height();

        var classA = 'vm_position_left vm_position_right vm_position_top vm_position_bottom';
        video.removeClass(classA);
        slide.removeClass(classA);
        if (mcw >= mch) {
            dsw = dsw / 2;
            if (this.videoonright == 1) {
                video.addClass('vm_position_right');
                slide.addClass('vm_position_left');
            } else {
                video.addClass('vm_position_left');
                slide.addClass('vm_position_right');
            }
        } else {
            dsh = dsh / 2;
            if (this.videoonright == 1) {
                video.addClass('vm_position_bottom');
                slide.addClass('vm_position_top');
            } else {
                video.addClass('vm_position_top');
                slide.addClass('vm_position_bottom');
            }
        }
    }

    var scale = Math.min(dsw / this.defaultSlideW, dsh / this.defaultSlideH);
    var _dsw = this.defaultSlideW * scale;
    var _dsh = this.defaultSlideH * scale;
    if (this.bothVideoSlide == 5) {
        video.width(_dsw);
        video.height(_dsh);
        slide.width(_dsw);
        slide.height(_dsh);
    } else {
        var target = (this.bothVideoSlide == 1) ? video : slide
        target.width(_dsw);
        target.height(_dsh);
    }

    var poster = $('.vm_video_poster', this.mc);
    var vpw = poster.width();
    var vph = poster.height();
    var posterImg = $('.vm_video_poster img', this.mc);
    this.imageResize(posterImg, vpw, vph, true);
    var video = $('video', this.mc);
    video.css("width",_dsw);
    video.css("height",_dsh);
    var slideHolder = $('.vm_slide_holder', this.mc);
    var shw = slideHolder.width();
    var shh = slideHolder.height();
    slideHolder.children().each(function() {
        self.imageResize($(this), shw, shh, true);
    });
}
VCASMOPlayer.prototype.videoSlideLiquidize1 = function() {
    // NOTE: customized layout should override this with own implementation
    // for customized layout
    var video = $('.vm_video', this.mc);
    var slide = $('.vm_slide', this.mc);
    var video_holder = $('.vm_video_holder', video);
    var slide_holder = $('.vm_slide_holder', slide);
    var thumb = $('.vm_thumbnail', this.mc);
    var thumb_panel = $('.vm_thumbnail_panel', thumb);
    var thumb_holder = $('.vm_thumbnail_holder', thumb_panel);
    var cat_panel = $('.vm_category_panel', this.mc);
    var cat_holder = $('.vm_category_holder', cat_panel);
    var slideInfo = $('.vm_slideInfo', this.mc);	// no need use video as base reference, because slideInfo may be moved
    var videoInfo = $('.vm_videoInfo', this.mc);	// no need use slide as base reference, because videoInfo may be moved
    
    var siH = this.layoutObj.siH;
    var viH = this.layoutObj.viH;
    var sborderLineThickW = this.layoutObj.sborderLineThickW
	var sborderLineThickH = this.layoutObj.sborderLineThickH;
	var vborderLineThickW = this.layoutObj.vborderLineThickW;
	var vborderLineThickH = this.layoutObj.vborderLineThickH;
    var cborderLineThickW = this.layoutObj.cborderLineThickW;
    var cborderLineThickH = this.layoutObj.cborderLineThickH;
    var tborderLineThickW = this.layoutObj.tborderLineThickW;
    var tborderLineThickH = this.layoutObj.tborderLineThickH;
 
    var gap = this.layoutObj.gap;
    var fullW = this.layoutObj.fullW;
    var fullH = this.layoutObj.fullH;
    var videoPartW = this.layoutObj.videoPartW;
    var slidePartW = this.layoutObj.slidePartW;
    var hozThumbH = this.layoutObj.hozThumbH;
    var videoRatio = this.layoutObj.videoRatio;
    var slideRatio = this.layoutObj.slideRatio;
   
    var mcw = this.mc.width();
    var mch = this.mc.height();

    var tw = thumb.width();
    var thumbPanelW = tw+gap;
    if (this.bothVideoSlide < 3 || !this.isThumbScrollVertical) {
        // 0 = unknown, 1 = video only, 2 = audio only
        tw = 0;
        thumbPanelW = 0;
    }    
    var design_vsW = fullW-thumbPanelW;
    var screen_vsW = mcw-thumbPanelW;
    var designRatio = fullW/fullH;
    var screenRatio = mcw/mch;
    var videoPart = videoPartW/design_vsW;
    var slidePart = slidePartW/design_vsW;
    var _sw = 0;
    var _sh = 0;
    var _vw = 0;
    var _vh = 0;
    
    if (this.bothVideoSlide<5) {
    	// no need two panel, do not set to 1, otherwise, category will be too narrow in some screen size
    	slidePart = 0.8;
    }
    
    if (screenRatio>=designRatio) {
        // fit height first
        // with subtitle, even video/audio/slide only, still need to need video/slide width, because using video width as category width
        if (this.bothVideoSlide == 5 || this.subtitleALen>0) {
            _sw = (mch-siH-hozThumbH-sborderLineThickH)*slideRatio+sborderLineThickW;
            _sh = mch-hozThumbH;
            _vh = (_sh+hozThumbH)/2;
            _vw = (_vh-viH-vborderLineThickH)*videoRatio+vborderLineThickW;
            //_vh = (_vw-vborderLineThickW)/videoRatio+viH+vborderLineThickH;
        } else {
            if (this.bothVideoSlide == 1 || this.bothVideoSlide == 2) {
                _sh = _vh = mch;
                _vw = (_vh-viH-vborderLineThickH)*videoRatio+vborderLineThickW;
            } else {
                _sh = mch-hozThumbH;
                _sw = (_sh-siH-sborderLineThickH)*slideRatio+sborderLineThickW;
            }
        }
    } else {
        // fit width first
        // with subtitle, even video/audio/slide only, still need to need video/slide width, because using video width as category width
        if (this.bothVideoSlide == 5 || this.subtitleALen>0) {
            _sw = screen_vsW*slidePart;
            _sh = (_sw-sborderLineThickW)/slideRatio+siH+sborderLineThickH-hozThumbH;
            if (_sh>mch-hozThumbH) {
                _sh=mch-hozThumbH;
                _sw=(_sh-siH-sborderLineThickH)*slideRatio+sborderLineThickW;
            }
            _vw = screen_vsW-_sw-gap;
            _vh = (_vw-vborderLineThickW)/videoRatio+viH+vborderLineThickH;
        } else {
            if (this.bothVideoSlide == 1 || this.bothVideoSlide == 2) {
                _vw = screen_vsW;
                _vh = (_vw-vborderLineThickW)/videoRatio+viH+vborderLineThickH;
                if (_vh>mch) {
                    _vh=mch;
                    _vw=(_vh-viH-vborderLineThickH)*videoRatio+vborderLineThickW;
                }
                _sh = _vh;
            } else {
                _sw = screen_vsW;
                _sh = (_sw-sborderLineThickW)/slideRatio+siH+sborderLineThickH;
                if (_sh>mch-hozThumbH) {
                    _sh=mch-hozThumbH;
                    _sw=(_sh-siH-sborderLineThickH)*slideRatio+sborderLineThickW;
                }
            }
        }
    }
    _sw = Math.round(_sw);
    _sh = Math.round(_sh);
    _vw = Math.round(_vw);
    _vh = Math.round(_vh);
    slide.width(_sw);
    slide.height(_sh);
    video.width(_vw);
    video.height(_vh);
    if (hozThumbH==0) {
    	thumb.height(_sh);
    }
    var _shW = _sw-sborderLineThickW;
    var _shbW = _shW;
    var _shH = _sh-sborderLineThickH-siH;
    var slide_holder_bg = $('.vm_slide_holder_bg', slide);
    slide_holder_bg.width(_shW);
    slide_holder_bg.height(_shH);
    var _shRatio = _shW/_shH;
    if (_shRatio>slideRatio) {
    	_shW = _shH*slideRatio;
    }
    slide_holder.width(_shW);
    slide_holder.height(_shH);
    slide_holder.css('left', ((_shbW-_shW)/2)+'px');
    var _dsw = _vw-vborderLineThickW;
    var _dsh = _vh-vborderLineThickH-viH;
    video_holder.width(_dsw);
    video_holder.height(_dsh);
    
    var video2 = $('video', this.mc);
    video2.css('width',_dsw);
    video2.css('height',_dsh);
    
    thumb_panel.height(_sh-tborderLineThickH);
    var vgap = (this.bothVideoSlide != 4) ? gap : 0;
    var sgap = (this.bothVideoSlide > 2) ? gap : 0;
    if (this.subtitleALen>0 && this.bothVideoSlide<5) {
    	vgap = gap;
    }
    var mcx = 0;
    var vstW = _vw+vgap+_sw+sgap+tw;
    mcx = (mcw-vstW)/2;
    
    var caption = $('.vm_category', this.mc);
    
    var firstplay = $('.vm_btn_firstplay', this.mc);
    var _mcy = 0;
    
    // full screen valign:middle
    if (!$.isFramed) {
        if (screenRatio>=designRatio) {
            video.css('top', 0);
            slide.css('top', 0);
            thumb.css('top', 0);
            caption.css('top', gap+_vh);
        } else {
        	_mcy = (mch-(_sh+hozThumbH))/2;
            var mcy = _mcy+'px';
            video.css('top', mcy);
            slide.css('top', mcy);
            thumb.css('top', mcy);
            caption.css('top', _mcy+gap+_vh+'px');
        }
        firstplay.css('bottom', 0);
    } else {
    	var fpsh = _sh;
    	if (!this.isThumbScrollVertical && this.slide_total>0) {
    		fpsh += gap+hozThumbH;
    	}
        firstplay.css('top', (fpsh-firstplay.height())/2+'px');
        caption.css('top', gap+_vh);
    }   
    if (this.videoonright == 0) {
        video.css('left', mcx+'px');
        caption.css('left', mcx+'px');
        var middleX = _vw+vgap+mcx;
        slide.css('left', middleX+'px');
        thumb.css('left', (middleX+_sw+gap)+'px');
    } else {
        thumb.css('left', mcx+'px');
        var middleX = thumbPanelW+mcx;
        slide.css('left', middleX+'px');
        var _vl = (middleX+_sw+gap)+'px';
        video.css('left', _vl);
        caption.css('left', _vl);
    }	   
	if (this.subtitleALen>0) {
	    caption.width(_vw);
	    caption.height(cateH);
	    var catHolder_w = _vw-cborderLineThickW;

		if (this.bothVideoSlide<3) {
    		if (this.videoonright == 0) {
    			caption.css('left', mcx+_sw+gap+'px');
    			video.css('left', mcx+'px');
    		} else {
    			caption.css('left', mcx+'px');
    			video.css('left', mcx+caption.width()+gap+'px');
    		}
    		_vw = _sw;
    		_vh = _sh;
    		video.width(_vw);
    		video.height(_vh);
    		_dsw = _vw-vborderLineThickW;
		    _dsh = _vh-vborderLineThickH-viH;
		    video_holder.width(_dsw);
		    video_holder.height(_dsh);
		    video2.css('width',_dsw);
		    video2.css('height',_dsh);
    	}
	    var cateH = _sh-gap-_vh+hozThumbH
	    if (this.bothVideoSlide<5) {
	    	cateH = _sh+hozThumbH;
	    	caption.css('top', _mcy+'px');
	    }
	    var catHolder_h = cateH-cborderLineThickH;
	    cat_panel.height(catHolder_h);
	    cat_panel.width(catHolder_w);
	    cat_holder.width(catHolder_w);
	}
}
VCASMOPlayer.prototype.setProcessWidth = function(pw) {
    var process = $('.vm_process', this.mc);
    process.width(pw);
    $('.vm_process .vm_slider_barknoll_holder', this.mc).width(pw - 9);
}
VCASMOPlayer.prototype.onFullScreen = function(bool) {
    if (bool) {
        $('.vm_btn_enlarge', this.mc).hide();
        $('.vm_btn_shrink', this.mc).show();
        this.mc.css('background-color', 'transparent');
    } else {
        $('.vm_btn_enlarge', this.mc).show();
        $('.vm_btn_shrink', this.mc).hide();
        if (this.vo.swfbgcolor) {
            this.mc.css('background-color', '#' + this.vo.swfbgcolor);
        }
    }
}

VCASMOPlayer.prototype.loadSpeakerPpt = function(dataPath) {
    var self = this
    $.ajax({
        type : 'GET',
        url : dataPath,
        dataType : 'xml',
        success : function(xml) {
            self.parseSpeakerXML(xml);
        },
        error : function() {
            self.onLoadSpeakerPptFail()
        }
    });
    // IE9 not support CORS in XMLHttpRequest. must use XDomainRequest, but jQuery not support
}
VCASMOPlayer.prototype.parseSpeakerXML = function(_xml) {
    var self = this;
    var xml = this.speakerListXML = $(_xml);
    var presentationNode = xml.find('presentation');
    var pid = presentationNode.attr('presentationid');
    var userid = presentationNode.attr('userid');
    this.inPortal = presentationNode.attr('inportal');
    var showlogo = presentationNode.attr('showlogo');
    var cuepoint = xml.find('cuepoint');
    var slidelink = xml.find('slidelink');
    var embeddomain = presentationNode.attr('embeddomain');
    if (embeddomain == undefined) {
    	embeddomain = '';
    }
    var md5Str = pid+this.inPortal+userid+showlogo+embeddomain;
    var checksum = xml.find('checksum').text();
    
    this.emailLink = xml.find('email').attr('emailLink');
    if (this.emailLink) {
	    if (this.emailLink.indexOf('http') == 0) {
	        this.directURL = this.emailLink;
	    } else {
	        this.emailLink = this.directURL+this.emailLink;
	        if (this.inPortal==1) {
	            var st = xml.find('subtitles').attr('st')
	            if (st) {
	            	this.emailLink += '%26st='+st;
	            }
	            this.directURL = this.emailLink;
	        } else {
		    	// NOTE: if inPortal=0, actually cannot link back, should hide email button, but if user set own email link, email button should keep
				$('.vm_btn_email', this.mc).hide();
	        }
	    }
    } else {
    	$('.vm_btn_email', this.mc).hide();
    }
    if (presentationNode.attr('thumbnail').indexOf('vcasmo.com') > 0) {
        this.assetPath = 'https://asset.vcasmo.com/';
        this.videoPath = 'https://d2dlqkztkvsfo5.cloudfront.net/';
        this.videoCDNPath = 'https://d2dlqkztkvsfo5.cloudfront.net/';
    }
    if (this.vo.apath) {
        this.assetPath = this.vo.apath;
    }
    if (this.vo.vpath) {
        this.videoPath = this.vo.vpath;
    }
    if (this.vo.vcpath) {
        this.videoCDNPath = this.vo.vcpath;
    }
    this.emailSubject = xml.find("emailSubject").text();
    this.emailContent = xml.find("emailContent").text();
    if (!presentationNode.attr('presentationid')) {
        this.addLogo(this.vo.vcasmo_full);
        this.showMsgWithUI('Private presentation not for public playing.', this.vo.vcasmo_full);
        this.errorExit('privatePresentation');
        return false;
    }
    document.title = xml.find("topic").text();
    this.traneffect = presentationNode.attr('traneffect');
    this.videoonright = presentationNode.attr('videoonright');
    
    if (this.vo.inAPI == 1) {
    	this.assetPath = this.videoPath = this.videoCDNPath = '';
    	this.traneffect = (this.vo.traneffect=='none') ? 'none' : 'fade';
    	if (this.vo.videoonright==1) {
    		this.videoonright = 1;
    	}
    }

    // cuepoint
    this.cuePointA = [0];
    cuepoint.each(function(index){
        var seqtime = $(this).attr('seqtime');
        md5Str += seqtime;
        if (index>0) {
            self.cuePointA.push(seqtime);
        }
    });
    this.cuePointALen = this.cuePointA.length;
    md5Str = MD5(md5Str);
    
    if (checksum != md5Str) {
        this.showMsgWithUI('Presentation data has been modified invalidly.', this.vo.vcasmo_full);
        this.errorExit('invalidData');
        return false;
    }
    if (embeddomain) {
    	if (!this.embeddomain(embeddomain)) {
    		this.showMsgWithUI('Presentation is not found.', this.vo.vcasmo_full);
            this.errorExit('presentationNotFound');
        	return false;
    	}
    }
    
    // slidelink
    slidelink.each(function(index){
    	var sno = parseInt($(this).attr('slideno'))-1;
    	if (!self.slideLinkA[sno]) {
    		self.slideLinkA[sno] = [];
       	}
       	self.slideLinkA[sno].push({u:$(this).attr('slidelink'),x:$(this).attr('hitareax'),y:$(this).attr('hitareay'),w:$(this).attr('hitareaw'),h:$(this).attr('hitareah'),nw:$(this).attr('newwin')})
    });
    
    // subtitle
    xml.find('subtitle').each(function(index){
        self.subtitleA.push({ts:$(this).attr('ts'),te:$(this).attr('te'),text:$(this).text()});
    });
    this.subtitleALen = this.subtitleA.length;
    if (this.subtitleALen>0) {
        this.subtitleText = $('.vm_subtitle_text', this.mc);
    }
    if (this.vo.extjs==1) {
    	var videoSeqA = [{ppt:1, slide:1, sec:0}]
    	for (var i=1;i<this.cuePointALen;i++) {
			videoSeqA.push({ppt:1, slide:i+1, sec:parseInt(this.cuePointA[i])});
	    };
    	this.dispatchEvent('vcasmoOnGetSeqData',videoSeqA);
    }
    this.genUI();
}
VCASMOPlayer.prototype.embeddomain = function(validdomain) {
	var host = '';
	try {
		host = top.location.host
		if (this.isVMHost(host)) {
			return true;
		}
	} catch (error) {
		host = document.referrer.split('/')[2];
		if (this.isVMHost(host)) {
			host = this.vo.referrer;
			if (host) {
				if (this.isVMHost(host)) {
					return true;
				}
				host = host.split('/')[2];
			} else {
				// view in vcasmo, directly iframe to html5, no vo.referrer
				return true;
			}
		}
	}
	if (host) {
		return this.embeddomain2(host, validdomain);
	} else {
		return false;
	}
}
VCASMOPlayer.prototype.embeddomain2 = function(host, validdomain) {
	var vdA = validdomain.split(" ");
	var vdALen = vdA.length
	for (var i = 0; i < vdALen; i++) {
		if (vdA[i]) {
			if (vdA[i].toLowerCase() == host) {
				return true;
			}
		}
	}
	var hostA = host.split(".");
	hostA.shift();
	host = hostA.join(".");
	for (i = 0; i < vdALen; i++) {
		if (vdA[i]) {
			if (vdA[i].toLowerCase() == host) {
				return true;
			}
		}
	}
	return false;
}
VCASMOPlayer.prototype.isVMHost = function(host) {
	if (host.indexOf('vcasmo.com')>0) {
		return true;
	}
	if (host.indexOf('luarsproduction.netdna-ssl.com')>0) {
		return true;
	}
	if (host=='dpf94gmwvoevx.cloudfront.net' || host=='d1ap128wkmh29n.cloudfront.net' || host=='d2dlqkztkvsfo5.cloudfront.net') {
		return true;
	}
	return false;
}
VCASMOPlayer.prototype.onLoadSpeakerPptFail = function() {
    this.addLogo(this.vo.vcasmo_full);
    this.showMsgWithUI('Cannot load speaker file.', this.vo.vcasmo_full);
    this.errorExit('speakerFileNotFound');
}
VCASMOPlayer.prototype.showMsgWithUI = function(str, hideUI) {
    var self = this;
    $('.vm_btn_firstplay', this.mc).hide();
    if (hideUI) {
	    $('.vm_category', this.mc).hide();
	    $('.vm_video', this.mc).hide();
	    $('.vm_slide', this.mc).hide();
	    $('.vm_thumbnail', this.mc).hide();
    }
    this.showMsg(str);
    this.checkKeptBtn();
    setTimeout(function() {
        self.layoutLiquidize();
        self.videoSlideLiquidize();
    }, 10);
    this.mc.show();
}
VCASMOPlayer.prototype.genUI = function() {
    var self = this;
    var needAddLogo = false;
    var supportedMedia = true;
    if (this.speakerListXML.find('presentation').attr('showlogo') == 1) {
        needAddLogo = true;
        if ($.isFramed) {
            trace ('framed url', document.referrer);
            var vcamsoURLIndex = document.referrer.indexOf('://www.vcasmo.com/')
            if (vcamsoURLIndex==4 || vcamsoURLIndex==5) {
                needAddLogo = false;
            }
        }
    } else {
    	if (this.vo.logoPath) {
    		this.addOtherLogo(this.vo.vcasmo_full);
    	}
    }
    if (needAddLogo) {
        this.addLogo(this.vo.vcasmo_full);
    }
    this.duration_total = Number(this.speakerListXML.find('presentation').attr('duration'));
    var slide_total = this.slide_total = this.speakerListXML.find("cuepoint").length;
    this.currentTime = $('.vm_duration_current', this.mc);
    this.videoBarknoll = $('.vm_process .vm_slider_barknoll', this.mc);
    this.currentTimeBar = $('.vm_process .vm_slider_current', this.mc);
    this.loadBar = $('.vm_process .vm_slider_loading', this.mc);
    var dur_str = this.secToHMS(this.duration_total);
    $('.vm_duration_total', this.mc).text(dur_str);
    this.showHideBtn('.vm_btn_previousSlide', false);
    this.showHideBtn('.vm_btn_nextSlide', false);
    var slide_holder = $('.vm_slide_holder', this.mc)
    slide_holder.empty();
    var thumb_holder = (!this.vo.vcasmo_full) ? $('.vm_dualscreen_thumbnail .vm_thumbnail_holder', this.mc) : $('.vm_thumbnail .vm_thumbnail_holder', this.mc);
    thumb_holder.empty();
    if (slide_total > 0) {
        $('.vm_slideno', this.mc).show();
        $('.vm_slideno_current', this.mc).text(1);
        $('.vm_slideno_total', this.mc).text(slide_total);
        var slideNode = this.speakerListXML.find("slide")
        slideNode.each(function(index) {
            self.slideObj[$(this).attr('assetid')] = index;
        });
        
        // thumbUnit
        var img = null;
        var timg = null;
        this.speakerListXML.find("cuepoint").each(function(index) {
            var _slideNode = slideNode.eq(self.slideObj[$(this).attr('assetid')])
            var filePath = _slideNode.attr('file');
            var fileType = _slideNode.attr('filetype');
            var isImg = true;
            if (fileType == 'ppt' || fileType == 'pdf') {
                filePath += '_' + $(this).attr('slideno') + '_l.jpg';
            } else if (fileType != 'swf') {
            	// jpg, gif, png
                filePath += '_l.'+_slideNode.attr('fileext');
            } else {
            	// swf
            	filePath = 'images/blank.gif';
            	isImg = false;
            }
            if (self.vo.inAPI==1) {
            	filePath = $(this).attr('path');
            	if (filePath.indexOf('.swf')==filePath.length-4) {
            		filePath = 'images/blank.gif';
            		isImg = false;
            	}
            }
            var seqtime = $(this).attr('seqtime');
	        var tbLabel = (index + 1) + ' / ' + self.slide_total;
			filePath = (isImg) ? self.assetPath + filePath : filePath;
			
            var imgStr = '<img data-original="' + filePath + '" src="' + self.indicator + '" slideno="'+index+'" class="vm_slide_image" />';
            img = $(imgStr);
            
            if (index == 0 || self.vo.vcasmo_full) {
                img.lazyload().trigger("appear").load(function() {
                    if (index == 0) $(this).show();
                    self.slideLoaded($(this), true);
                });
            }
            
            slide_holder.append(img);
                        
            if (self.slideLinkA[index]) {
            	img.attr('usemap', 'map_'+index);
            	var mapElement = self.slideLinkA[index];
            	var mapStr = '<div class="vm_imagemap" id="map_'+index+'">';
            	var mapLen = mapElement.length;
            	for (var i=0;i<mapLen;i++) {
            		// NOTE: not use defaultSlideW/defaultSlideH to calculate
            		var coord = (mapElement[i].w) ? 'left:'+Math.round((mapElement[i].x/411)*100)+'%;top:'+Math.round((mapElement[i].y/308)*100)+'%;width:'+Math.round((mapElement[i].w/411)*100)+'%;height:'+Math.round((mapElement[i].h/308)*100)+'%' : 'width:100%;height:100%';
            		var targetStr = (mapElement[i].nw==1) ? 'target="_blank"' : 'target="_top"';
            		mapStr += '<a class="vm_imagemap_a" style="'+coord+'" alt="'+mapElement[i].u+'" title="'+mapElement[i].u+'" href="'+mapElement[i].u+'"'+targetStr+'></a>';
            	}
            	mapStr += '</div>';
            	slide_holder.append($(mapStr));
            }

            // NOTE: cannot use touchEvent here, because thumbnail panel need touch scrolling
            timg = $('<div slideno="' + index + '" seqtime="' + seqtime + '" title="' + tbLabel + '" alt="' + tbLabel + '">' + imgStr + '</div>').on('click', function() {
                if (self.isAutoPlay) {
                    self.loadSlide(parseInt($(this).attr('slideno')), true, false);
                }
            });

            thumb_holder.append(timg);
        });
        thumb_holder.append('<div class="spacer"></div>');
        if (this.vo.vcasmo_full) {
            // customized layout
            $('.vm_thumbnail', this.mc).show();
            $('.vm_thumbnail_holder img', this.mc).each(function(index) {
                $(this).lazyload().trigger("appear").load(function() {
                    $(this).parent().addClass('loaded');
                    if ($(this).attr('src') != self.indicator) {
                    	self.loadedSlideCount++;
                    }
                    if (self.loadedSlideCount == self.slide_total) {
                        $('.vm_btn_printAll').removeClass('vm_btn_disabled');
                        self.mc.trigger('vcasmoSlidesAllLoaded');
                    }
                    self.slideLoaded($(this).show(), false);
                });
            });
        }
        /*thumb_holder.scrollStartPos = 0;
        thumb_holder.on('touchstart', function(evt) {
            evt.target.scrollStartPos = this.scrollTop + evt.originalEvent.touches[0].pageY;
        });
        thumb_holder.on('touchmove', function(evt) {
            this.scrollTop = evt.target.scrollStartPos - evt.originalEvent.touches[0].pageY;
            evt.preventDefault();
        });*/
        var thumb = $('.vm_dualscreen_thumbnail', this.mc);
        thumb.attr('oldRight', thumb.css('right'));
        var thumb_btn = $('.vm_thumbnal_btn', this.mc);
        thumb_btn.attr('oldRight', thumb_btn.parent().css('right'));

        // NOTE: cannot use touchEvent here, because it will cause thumbnail be touched, too
        thumb_btn.on('click', function() {
            self.showHideDualThumbnailPanel();
        });
        this.mc.append('<div class="vm_paper"></div>');
        
        if (this.isThumbScrollVertical) {
            this.thumbUnitSize = timg.height()+timg.cssNo('margin-bottom');
        } else {
            this.thumbUnitSize = timg.width()+timg.cssNo('margin-right');
        }
        
        if (this.speakerListXML.find("canPrint").attr('value')==0 || this.vo.canprint==0) {
            $('.vm_btn_prints_holder', this.mc).hide();
        }
        
        if (this.vo.vcasmo_full) {
            this.showHideThumbScrollBar(true);
        }
    } else {
        $('.vm_slideno', this.mc).hide();
        $('.vm_slide', this.mc).hide();
        $('.vm_video', this.mc).css('width', '100%');
        $('.vm_btn_prints_holder', this.mc).hide();
        $('.vm_thumbnail', this.mc).hide();
    }
    if (slide_total < 2) {
        $('.vm_btn_previousSlide', this.mc).hide();
        $('.vm_btn_nextSlide', this.mc).hide();
    }
    var videoNode = this.speakerListXML.find("video")
    var videoLen = videoNode.length;
    var filetype = '';
    if (videoLen > 0) {
        filetype = videoNode.attr('filetype');
        var _filetype = filetype;
        var videoseqno = videoNode.attr('videoseqno');
        if (isNaN(parseInt(videoseqno))) {
        	videoseqno = 0;
        }
        if (videoseqno>0 && $.isIOS) {
        	filetype = 'mp4';
	        _filetype = 'm3u8';
	        $.isHLS = true;
        }
    	if (filetype == 'mp4') {
            this.media = $('video', this.mc);
        } else if (filetype == 'mp3') {
            this.media = $('audio', this.mc);
        } else {
        	supportedMedia = false;
            setTimeout(function(){
            	self.showMsgWithUI('The video format has not yet supported to play.', false);
            }, 30);
            self.errorExit('videoFormat');
            //return false;
        }
        if (supportedMedia) {
	        if (videoNode.attr('streampath')) {
	            this.media.attr('src', this.videoCDNPath + videoNode.attr('file') + '.' + _filetype);
	        } else {
	            this.media.attr('src', this.videoPath + videoNode.attr('file') + '.' + _filetype);
	        }
	        if (this.vo.inAPI == 1) {
	        	var folder = videoNode.attr('folder');
	        	if (folder.lastIndexOf('/') != folder.length-1) {
	        		folder += '/';
	        	}
	        	this.media.attr('src', folder + videoNode.attr('file') + '.' + videoNode.attr('fileext'));
	        }
	        this.media.on('loadedmetadata', function() {
	            self.netStreamOnMetaData();
	        })
	        this.media.on('play', function() {
	            self.netStreamOnStatus('play', 'play');
	            self.netStreamOnStatus('bufferFull', 'play');
	        })
	        this.media.on('playing', function() {
	            self.netStreamOnStatus('play', 'playing');
	            self.netStreamOnStatus('bufferFull', 'playing');
	        })
	        this.media.on('canplay', function() {
	            self.netStreamOnStatus('bufferFull', 'canplay');
	            var isPaused = self.media.prop('paused');
	            //trace ('canplay', 'self', self.shouldPlayAfterSeek, 'isPaused',isPaused, 'streamIsStop', self.streamIsStop)
	            if (self.shouldPlayAfterSeek && isPaused && !self.streamIsStop) {
	                self.media.trigger('play');
	            }
	            self.shouldPlayAfterSeek = false;
	        })
	        this.media.on('seeked', function() {
	            self.netStreamOnStatus('bufferFull', 'seeked');
	            var isPaused = self.media.prop('paused');
	            self.shouldPlayAfterSeek = (self.isPlaying && !isPaused);
	            //trace ('seeked', 'self.shouldPlayAfterSeek', self.shouldPlayAfterSeek, 'isPaused',isPaused, 'isPlaying', self.isPlaying)
	        })
	        this.media.on('progress', function() {
	            self.videoLoader($(this).prop('buffered').end(0));
	        })
	        this.media.on('timeupdate', function() {
	            self.showVideoTime($(this).prop('currentTime'));
	        })
	        this.media.on('waiting', function() {
	            self.netStreamOnStatus('bufferEmpty', 'waiting');
	        })
	        this.media.on('pause', function() {
	            self.netStreamOnStatus('pause', 'pause');
	            //trace ('paused', self.shouldPlayAfterSeek, self.isPlaying, self.streamIsStop,$(this).prop('currentTime'), self.duration_total);
	            if ($(this).prop('currentTime') < self.duration_total && self.shouldPlayAfterSeek && self.isPlaying && !self.streamIsStop) {
	                self.media.trigger("play");
	            }
	        })
	        this.media.on('ended', function() {
	            self.netStreamOnStatus('ended', 'ended');
	        })
        }
        var posterPath = this.speakerListXML.find('presentation').attr('thumbnail');
        if (!supportedMedia) {
        	posterPath = posterPath.replace('_l.', '_m.');
        }
        if ('https:' == document.location.protocol) {
            posterPath = posterPath.replace('http://asset.vcasmo.com/', this.assetPath);
        }
        var poster = $('<img data-original="' + posterPath + '" src="' + self.indicator + '" class="vm_slide_image" />');
        $('.vm_video_poster', this.mc).append(poster);
        poster.show().lazyload().trigger("appear").load(function() {
            $(this).show();
            self.slideLoaded($(this), false);
        })
        if (this.vo.inAPI==1) {
        	$('<img src="' + posterPath+'">').error(function() {
	            poster.hide();
	        });
        }
    } else {
        $('.vm_volume', this.mc).hide();
        $('.vm_video', this.mc).hide();
        $('.vm_slide', this.mc).css('width', '100%').css('left', '0');
    }
    if (videoLen > 0 && slide_total > 0) {
        this.bothVideoSlide = (filetype == 'mp4') ? 5 : 3;
        if (!this.vo.vcasmo_full) {
            // dual screen
            if (this.bothVideoSlide == 3) {
                // audio + slide
                $('.vm_video_poster', this.mc).hide();
            }
        }
    } else if (videoLen > 0) {
        this.bothVideoSlide = (filetype == 'mp4') ? 1 : 2;
    } else if (slide_total > 0) {
        this.bothVideoSlide = 4;
    }
    if (this.vo.vcasmo_full) {
    	var video_holder = $('.vm_video_holder', this.mc);
	    var cat_panel = $('.vm_category_panel', this.mc);
    	var slideInfo = $('.vm_slideInfo', this.mc);
    	var videoInfo = $('.vm_videoInfo', this.mc);
    	var category = $('.vm_category', this.mc);
		
    	$('.vm_subtitle', this.mc).appendTo(video_holder);
		
    	if (this.bothVideoSlide == 3 || this.bothVideoSlide == 4) {
    		// 3 = audio + slide, 4 = slide only
    		// move videoInfo buttons into slideInfo
    		$('.clear', videoInfo).remove();
    		slideInfo.children().each(function(){
    			$(this).appendTo(videoInfo);
    		});
    		slideInfo.remove();
    		videoInfo.appendTo($('.vm_slide', this.mc));
    	} else {
    		// align slideInfo buttons to right
    		$(slideInfo.children().get().reverse()).appendTo(slideInfo);
    		$('.clear', slideInfo).appendTo(slideInfo);
    	}
	    if (this.bothVideoSlide < 3) {
			// video/audio only, move email, fullscreen button to videoInfo
			$('.vm_btn_email',slideInfo).appendTo(videoInfo);
			$('.vm_btn_fullscreen',slideInfo).appendTo(videoInfo);
			$('.clear',videoInfo).appendTo(videoInfo);
		}
    	if (this.subtitleALen>0) {
    		var cat_holder = $('.vm_category_holder', category);
            var strno = 0;
    		for (var i=0;i<this.subtitleALen;i++) {
                if (this.subtitleA[i].text) {
        			var rno = strno%2;
        			var catItem = $('<div id="vmCateItem'+i+'" class="vm_category_item'+rno+'" ts="'+this.subtitleA[i].ts+'">'+this.subtitleA[i].text+'&nbsp;</div>');
        			// NOTE: cannot use touchEvent here, because category panel need touch scrolling
        			catItem.on('click', function() {
    			        if (self.isAutoPlay) {
    			        	self.seekVideo($(this).attr('ts'));
    		        	}
    			    });
        			cat_holder.append(catItem);
                    strno++;
                }
    		}
    		this.cateScroll = cat_holder.parent().iscroll({hScroll:false,vScrollbar:true});
    	} else {
    		category.hide();
    	}

		this.layoutObj = {}
		this.layoutObj.gap = 4;
    	this.layoutObj.fullW = 850;
    	this.layoutObj.fullH = 382;
    	this.layoutObj.videoPartW = 303;
    	this.layoutObj.slidePartW = 424;
    	this.layoutObj.hozThumbH = 0;
    	this.layoutObj.videoRatio = this.layoutObj.slideRatio = 4/3;

		$('.vm_error_msg_holder', this.mc).appendTo(this.mc);
    	$('.vm_btn_firstplay', this.mc).appendTo(this.mc);
    }
    this.checkKeptBtn();
    $('.vm_btn_firstplay', this.mc).on($.clickEvent, function() {
        self.firstPlay();
    });
    $('.vm_btn_play', this.mc).on($.clickEvent, function() {
        self.videoinfo_play();
    });
    $('.vm_btn_pause', this.mc).on($.clickEvent, function() {
        self.videoinfo_pause();
    });
    $('.vm_btn_previousSlide', this.mc).on($.clickEvent, function() {
        if (!$(this).hasClass('vm_btn_disabled')) {
            self.slideNav(-1);
        }
    });
    $('.vm_btn_nextSlide', this.mc).on($.clickEvent, function() {
        if (!$(this).hasClass('vm_btn_disabled')) {
            self.slideNav(1);
        }
    });
    $('.vm_btn_print', this.mc).on($.clickEvent, function() {
        if (!$(this).hasClass('vm_btn_disabled')) {
            self.showHidePrintButton();
        }
    });
    $('.vm_btn_printAll', this.mc).on($.clickEvent, function() {
        if (!$(this).hasClass('vm_btn_disabled')) {
            self.slidePrintAll();
        }
    });
    $('.vm_btn_printCurrent', this.mc).on($.clickEvent, function() {
        if (!$(this).hasClass('vm_btn_disabled')) {
            self.slidePrint();
        }
    });
    var timeout = 10;
    if (this.vo.vcasmo_full && $.isIOS) {
    	timeout = 800;
    	slideInfo.hide();
		videoInfo.hide();
		slide_holder.hide();
		video_holder.hide();
		slideInfo.show();
		videoInfo.show();
		slide_holder.show();
		video_holder.show();
    	this.mc.css('visibility', 'hidden');
    }
    if (this.vo.nofs==1) {
    	$('.vm_btn_fullscreen', this.mc).remove();
    }
    this.mc.show();
    setTimeout(function() {
        if (!self.vo.vcasmo_full) {
            self.layoutLiquidize();
            self.videoSlideLiquidize();
        } else {
	    	self.layoutObj.siH = slideInfo.height()+slideInfo.cssNo('padding-top')+slideInfo.cssNo('padding-bottom')+slideInfo.cssNo('border-top-width')+slideInfo.cssNo('border-bottom-width');
		    self.layoutObj.viH = videoInfo.height()+videoInfo.cssNo('padding-top')+videoInfo.cssNo('padding-bottom')+videoInfo.cssNo('border-top-width')+videoInfo.cssNo('border-bottom-width');
		    if (self.layoutObj.siH==0 && self.layoutObj.viH>0) {
		    	// in audio+slide, slide_v, slide_h, all slideInfo buttons moved to videoInfo
		    	self.layoutObj.siH = self.layoutObj.viH
		    }
		    if (self.layoutObj.viH==0 && self.layoutObj.siH>0) {
		    	self.layoutObj.viH = self.layoutObj.siH
		    }
		    
		    // suppose should be padding, but padding not work, use margin instead
		    self.layoutObj.sborderLineThickW = slide_holder.cssNo('margin-left')+slide_holder.cssNo('margin-right');
		    self.layoutObj.sborderLineThickH = slide_holder.cssNo('margin-top')+slide_holder.cssNo('margin-bottom');
		    self.layoutObj.vborderLineThickW = video_holder.cssNo('margin-left')+video_holder.cssNo('margin-right');
		    self.layoutObj.vborderLineThickH = video_holder.cssNo('margin-top')+video_holder.cssNo('margin-bottom');
		    self.layoutObj.cborderLineThickW = cat_panel.cssNo('margin-left')+cat_panel.cssNo('margin-right');
		    self.layoutObj.cborderLineThickH = cat_panel.cssNo('margin-top')+cat_panel.cssNo('margin-bottom');
		    self.layoutObj.tborderLineThickW = thumb_holder.cssNo('margin-left')+thumb_holder.cssNo('margin-right');
		    self.layoutObj.tborderLineThickH = thumb_holder.cssNo('margin-top')+thumb_holder.cssNo('margin-bottom');
		    //trace ('layoutObj', self.layoutObj.siH,self.layoutObj.viH,self.layoutObj.sborderLineThickW,self.layoutObj.vborderLineThickW,self.layoutObj.cborderLineThickW,self.layoutObj.tborderLineThickW,self.thumbUnitSize)

            self.videoSlideLiquidize();
            self.layoutLiquidize();
            
            self.mc.css('visibility', 'visible');
        }
        var poster = $('.vm_video_poster', self.mc);
        var vpw = poster.width();
        var vph = poster.height();
        var video = $('video', self.mc);
        self.imageResize(video, vpw, vph, true);
        self.resizeScroller();
        
	    if (self.vo.autoplay==1 && (!$.isMobile || self.bothVideoSlide==4)) {
            // TODO: support autoplay in HTML5
	        /*setTimeout(function() {
	            self.firstPlay();
	        }, 1000);*/
	    }
    }, timeout);
    var labelStrA = ['.vm_duration_current, .vm_duration_sep', '.vm_duration_total', '.vm_slideno']
    for (var i=1;i<=3;i++) {
    	if (this.vo['labelColor'+i]) {
    		$(labelStrA[i-1], this.mc).css('color', '#'+this.vo['labelColor'+i]);
    	}
    	if (this.vo['labelAlpha'+i]) {
    		$(labelStrA[i-1], this.mc).fadeTo(0, this.vo['labelAlpha'+i]/100);
    	}
    }
    this.dispatchEvent('vcasmoUIReady');
}
VCASMOPlayer.prototype.initVolumeBar = function() {
    var self = this;
    var pbarknoll = $('.vm_volume .vm_slider_barknoll', this.mc);
    var pcurrent = $('.vm_volume .vm_slider_current', this.mc);
    pbarknoll.drag(function( ev, dd ){
        var parent = $(this).parent();
        var parentW = parent.width()
        var left = Math.max(0,Math.min(parentW, dd.offsetX-parent.offset().left));
        var ratio = left / parentW;
        var percent = (ratio * 100) + "%";
        $(this).css({left:percent});
        pcurrent.css('width', percent);
        self.media.prop('volume', ratio);
    });
    var pbar = $('.vm_volume .vm_slider_barknoll_holder', this.mc);
    pbar.on($.clickEvent, function(evt){
        var parentW = $(this).width()
        var left = Math.max(0,Math.min(parentW, evt.pageX - $(this).offset().left));
        var ratio = left / parentW;
        var percent = (ratio * 100) + "%";
        pbarknoll.css({left:percent});
        pcurrent.css('width', percent);
        self.media.prop('volume', ratio);
    });
}
VCASMOPlayer.prototype.initProcessBar = function() {
    var self = this;
    var pbarknoll = $('.vm_process .vm_slider_barknoll', this.mc);
    pbarknoll.drag(function( ev, dd ){
        var parent = $(this).parent();
        var parentW = parent.width()
        var left = Math.max(0,Math.min(parentW, dd.offsetX-parent.offset().left));
        var ratio = left / parentW;
        var percent = (ratio * 100) + "%";
        $(this).css({left:percent});
        self.timeCount = parseInt(self.duration_total*ratio)
        self.currentTime.text(self.secToHMS(self.timeCount));
        self.currentTimeBar.css('width', percent);
    });
    pbarknoll.on('dragend', function(){
        self.seekVideo(self.timeCount)
        self.showVideoTime(self.timeCount);
    });
    var pbar = $('.vm_process .vm_slider_barknoll_holder', this.mc);
    pbar.on($.clickEvent, function(evt){
        var parentW = $(this).width()
        var left = Math.max(0,Math.min(parentW, evt.pageX - $(this).offset().left));
        var ratio = left / parentW;
        var percent = (ratio * 100) + "%";
        pbarknoll.css({left:percent});
        self.timeCount = parseInt(self.duration_total*ratio)
        self.currentTime.text(self.secToHMS(self.timeCount));
        self.currentTimeBar.css('width', percent);
        self.seekVideo(self.timeCount)
        self.showVideoTime(self.timeCount);
    });
}    
VCASMOPlayer.prototype.calculateRatio = function(leftVal, widthVal) {
    leftVal = Math.max(0,Math.min(widthVal, leftVal));
    return leftVal / widthVal;
}
VCASMOPlayer.prototype.checkKeptBtn = function() {
    var self = this;
    if (!this.vo.vcasmo_full) {
    	// for standard dualscreen
    	$('.vm_dualController', this.mc).children().each(function(index) {
	        if (!$(this).hasClass('clear')) {
	            self.dualScreenControllerKeptBtn[index] = ($(this).css('display') != 'none') ? true : false;
	        }
	    });
    } else {
    	// for customized layout
    	$('.vm_videoInfo', this.mc).children().each(function(index) {
	        if (!$(this).hasClass('clear')) {
	            self.videoControllerKeptBtn[index] = ($(this).css('display') != 'none') ? true : false;
	        }
	    });
	    $('.vm_slideInfo', this.mc).children().each(function(index) {
	        if (!$(this).hasClass('clear')) {
	            self.slideControllerKeptBtn[index] = ($(this).css('display') != 'none') ? true : false;
	        }
	    });
    }
}
VCASMOPlayer.prototype.addLogo = function(atRBCorner) {
    var self = this;
    var styleStr;
    var logoMC
    // use full path for logo to prevent offline version image file be edited by others
    if (!atRBCorner) {
    	// for standard dualscreen
        styleStr = 'float:left;position:relative;top:5px;margin-right:11px;';
    } else {
    	// for customized layout
        styleStr = 'position:absolute;right:0;bottom:0;z-index:9999999;';
    }
    // TODO: support SSL
    logoMC = $('<div style="'+styleStr+'display:inline;cursor:pointer;min-width:77px;"><img src="'+this.logoPath+'html5/images/logo' + this.vo.logoType + '.png" /></div>');
    logoMC.on($.clickEvent, function() {
        window.open(self.directURL, '_blank');
    });
    if (!atRBCorner) {
        logoMC.insertBefore('.vm_dualController .clear', this.mc);
    } else {
        this.mc.append(logoMC);
    }
}
VCASMOPlayer.prototype.addOtherLogo = function(atRBCorner) {
    var self = this;
    var styleStr;
    var logoMC
    // use full path for logo to prevent offline version image file be edited by others
    if (!atRBCorner) {
    	// for standard dualscreen
        styleStr = 'float:left;position:relative;top:'+((this.vo.logoOffsetY)?-this.vo.logoOffsetY:0)+'px;margin-right:11px;';
    } else {
    	// for customized layout
        styleStr = 'position:absolute;right:0;bottom:0;z-index:9999999;';
    }
    logoMC = $('<div style="'+styleStr+'display:inline;min-width:77px;"><img src="' + this.vo.logoPath + '" /></div>');
    /*logoMC.on($.clickEvent, function() {
        window.open(self.directURL, '_blank');
    });*/
    if (!atRBCorner) {
        logoMC.insertBefore('.vm_dualController .clear', this.mc);
    } else {
        this.mc.append(logoMC);
    }	
}
VCASMOPlayer.prototype.firstPlay = function() {
    var self = this;
    $('.vm_btn_firstplay', this.mc).hide();
    if (this.bothVideoSlide != 4) {
        // has video / audio
        this.showBufferText(true);
        if (this.bothVideoSlide == 1 || this.bothVideoSlide == 5) {
            this.media.show();
        }
        this.media.trigger('play');
        if (!$.isMobile) {
            this.initVolumeBar();
        }
    } else {
        this.timer = $.timer(function(){
            self.timeCount++
            if (self.timeCount < self.duration_total) {
                self.showVideoTime(self.timeCount);
            } else {
                self.slideSequenceStop();
                self.showVideoTime(self.duration_total);
                this.stop();
                self.timeCount = 0;
                setTimeout(function() {
                    self.dispatchEvent('vcasmoStop', {sec:self.duration_total});
                }, 1000);
            }
         }, 1000, true)
    }
    if (this.bothVideoSlide > 2) {
        // has slide
        if (this.slide_total > 1) {
            $('.vm_dualscreen_thumbnail .vm_thumbnal_btn', this.mc).show();
        }
        $('.vm_btn_print').removeClass('vm_btn_disabled');
        $('.vm_slide_holder img', this.mc).each(function(index) {
            if (index > 0) {
                $(this).lazyload().trigger("appear").load(function() {
                    if (index == self.slide_current) {
                        $(this).show();
                    }
                    self.slideLoaded($(this), true);
                });
            }
        });
        if (!this.vo.vcasmo_full) {
            // dual screen
            $('.vm_thumbnail_holder img', this.mc).each(function(index) {
                $(this).lazyload().trigger("appear").load(function() {
                    if (index == self.slide_current) {
                        $(this).parent().addClass('highlight');
                    }
                    $(this).parent().addClass('loaded');
                    if ($(this).attr('src') != self.indicator) {
                    	self.loadedSlideCount++;
                    }
                    if (self.loadedSlideCount == self.slide_total) {
                        $('.vm_btn_printAll').removeClass('vm_btn_disabled');
                        self.mc.trigger('vcasmoSlidesAllLoaded');
                    }
                    self.slideLoaded($(this).show(), false);
                });
            });
        } else {
        	$('.vm_thumbnail_holder img', this.mc).eq(0).parent().addClass('highlight');
        }
        this.updateSlideNavBtn();
        setTimeout(function(){
        	$('.vm_slide_holder #map_0', this.mc).show();
        }, 1000);
        this.dispatchEvent('vcasmoFirstPlay');
    }
    if (this.subtitleALen>0 && this.vo.showsubtitle != '0') {
        $('.vm_subtitle', this.mc).show();
    }
    if (this.isMetaDataReady || this.bothVideoSlide == 4) {
        $('.vm_video_poster', this.mc).hide();
        this.initProcessBar();
        this.showHideVideoInfoBtn(false);
    }
    this.isPlaying = true;
    this.isAutoPlay = true;
}
VCASMOPlayer.prototype.netStreamOnStatus = function(infoCode, evtType) {
    if (!this.isAutoPlay)
        return false;
    trace ('netStreamOnStatus', infoCode, evtType)
    switch(infoCode) {
        case 'bufferFull':
			if (!$.isHLS) {
            	this.showBufferText(false);
			} else {
           		this.showBufferText((evtType=='seeked'));
			}
            break;
        case 'bufferEmpty':
            this.showBufferText(true);
            break;
        case 'play':
            this.showHideVideoInfoBtn(false);
            break;
        case 'pause':
            this.showHideVideoInfoBtn(true);
            break;
        case 'ended':
   			this.shouldPlayAfterSeek = false;
   			this.streamIsStop = true;
            this.videoinfo_pause();
            this.dispatchEvent('vcasmoStop', {sec:this.curNSTime});
            break;    
    }
}
VCASMOPlayer.prototype.netStreamOnMetaData0 = function() {
    // for standard dualscreen
    var videoContainer = $(".vm_video", this.mc);
    var vw = videoContainer.width();
    var vh = videoContainer.height();
    var video = $("video", this.mc);
    video.css("width", vw);
    video.css("height", vh);
    this.isMetaDataReady = true;
    if (this.isAutoPlay) {
        $('.vm_video_poster', this.mc).hide();
        this.initProcessBar();
        this.showHideVideoInfoBtn(false);
    }
    this.dispatchEvent('vcasmoOnMetaData');
}
VCASMOPlayer.prototype.netStreamOnMetaData1 = function() {
    // for customized layout
    this.netStreamOnMetaData0();
    var video_holder = $('.vm_video_holder', this.mc);
    var video = $('video', this.mc);
    video.css('width',video_holder.width());
    video.css('height',video_holder.height());
}
VCASMOPlayer.prototype.videoLoader = function(bytesLoaded) {
    var percent = (bytesLoaded / this.duration_total) * 100;
    if (percent < 100) {
        this.loadBar.css('width', percent + "%");
    } else {
        this.loadBar.hide();
    }
}
VCASMOPlayer.prototype.showVideoTime = function(nsTime) {
    if (!this.streamIsStop) {
    	this.curNSTime = nsTime;
    	this.currentTime.text(this.secToHMS(nsTime));
	    var percent = Math.max(0, Math.min(100, (nsTime / this.duration_total) * 100)) + "%";
	    this.currentTimeBar.css('width', percent);
	    this.videoBarknoll.css('left', percent);
	    this.synSlide(nsTime);
	    this.findCurSubtitleID(parseInt(nsTime));
    }
}
VCASMOPlayer.prototype.synSlide = function(nsTime) {
    for (var i=this.cuePointALen;i>=0;i--) {
        if (this.cuePointA[i]<=nsTime) {
            this.loadSlide(i, false, false);
            return;
        }
    }
}
VCASMOPlayer.prototype.findCurSubtitleID = function(nsTime) {
    if (this.subtitleALen>0) {
        for (var i=0;i<this.subtitleALen;i++) {
            var sub = this.subtitleA[i];
            if (sub.ts<=nsTime && sub.te>nsTime) {
                if (i != this.curSubtitleId) {
                	if (this.vo.vcasmo_full) {
	                	$('.vm_category_item_highlight', this.mc).removeClass('vm_category_item_highlight');
	                    this.curSubtitleId = i
	                    var curCateItem = $('#vmCateItem'+this.curSubtitleId, this.mc);
	                	curCateItem.addClass('vm_category_item_highlight');
	                	this.cateMoveTo(curCateItem.position().top);
                	}
                    this.setSubtitleMsg(sub.text);
                    this.dispatchEvent('vcasmoSubtitle', {id:this.curSubtitleId, msg:sub.text});
                }
                return;
            }
        }
        if (this.curSubtitleId != -1) {
            this.curSubtitleId = -1;
            this.setSubtitleMsg('&nbsp;');
        }
    }
}
VCASMOPlayer.prototype.setSubtitleMsg = function(str) {
    this.subtitleText.html(str);
}
VCASMOPlayer.prototype.cateMoveToLastPosition = function(speed) {
    this.cateScroll.scrollTo(0, this.lastCateScrollPos, speed);
}
VCASMOPlayer.prototype.cateMoveTo = function(sno) {
    var pos = Math.min(this.maxCateScrollRange, sno);
    this.lastCateScrollPos = -pos;
	this.cateMoveToLastPosition(500);
}
VCASMOPlayer.prototype.showBufferText = function(bool) {
    this.isBuffering = bool;
    if (bool) {
        $('.vm_slider_buffering', this.mc).show();
    } else {
        $('.vm_slider_buffering', this.mc).hide();
    }
}
VCASMOPlayer.prototype.videoinfo_play = function() {
    this.isPlaying = true;
    this.streamIsStop = false;
    if (this.isAutoPlay) {
        if (this.bothVideoSlide != 4) {
            this.media.trigger('play');
        } else {
            this.timer.play(false);
            this.netStreamOnStatus('play');
        }
        this.dispatchEvent('vcasmoResume', {sec:this.curNSTime});
    } else {
        this.firstPlay();
    }
}
VCASMOPlayer.prototype.videoinfo_pause = function() {
    this.isPlaying = false;
    if (this.bothVideoSlide != 4) {
        this.media.trigger('pause');
    } else {
        this.timer.pause();
        this.netStreamOnStatus('pause')
    }
    if (!this.streamIsStop) {
    	this.dispatchEvent('vcasmoPause', {sec:this.curNSTime});
    }
}
VCASMOPlayer.prototype.slideNav = function(dir) {
    clearTimeout(this.loadSlideTimeOutId);
    var self = this;
    this.tmp_slide_current = this.tmp_slide_current + dir * 1;
    this.tmp_slide_current = Math.min(this.slide_total - 1, Math.max(0, this.tmp_slide_current));
    this.setSlideno(this.tmp_slide_current);
    this.updateSlideNavBtn();
    this.loadSlideTimeOutId = setTimeout(function() {
        self.loadSlide(self.tmp_slide_current, true, false);
    }, 500);
}
VCASMOPlayer.prototype.loadSlide = function(slideno, needSync, noHighlight) {
    if (needSync) {
        clearTimeout(this.loadSlideTimeOutId);
    }
    if (slideno == this.slide_current) {
        return false;
    }
    //trace('loadSlide', slideno, needSync);
    this.swapSlide(this.slide_current, slideno)
    var thumbs = $('.vm_thumbnail_holder img', this.mc);
    thumbs.eq(this.slide_current).parent().removeClass('highlight');
    var thumb = thumbs.eq(slideno)
    if (thumb.parent().hasClass('loaded')) {
        thumb.parent().addClass('highlight');
    }
    this.tmp_slide_current = this.slide_current = slideno;
    this.setSlideno(slideno);
    this.updateSlideNavBtn();
    if (needSync) {
        var seqtime = Number($('.vm_thumbnail_holder div', this.mc).eq(this.slide_current).attr('seqtime'));
        this.seekVideo(seqtime);
    }
    if (!noHighlight) {
        this.tbMoveTo(slideno);
    }
    this.dispatchEvent('vcasmoSync', {ppt:1, slide:slideno+1, sec:(seqtime) ? seqtime : this.curNSTime});
}
VCASMOPlayer.prototype.seekVideo = function(seqtime) {
    if (this.bothVideoSlide != 4) {
        this.showBufferText(true);
        this.media.prop('currentTime', seqtime);
    } else {
        this.showVideoTime(seqtime);
        this.timeCount = seqtime;
    }
   	this.dispatchEvent('vcasmoSeekVideo', {sec:seqtime});
}
VCASMOPlayer.prototype.updateSlideNavBtn = function() {
    if (this.tmp_slide_current < this.slide_total - 1 && this.tmp_slide_current > 0) {
        $('.vm_btn_previousSlide', this.mc).removeClass('vm_btn_disabled');
        $('.vm_btn_nextSlide', this.mc).removeClass('vm_btn_disabled');
    } else if (this.tmp_slide_current == 0) {
        $('.vm_btn_previousSlide', this.mc).addClass('vm_btn_disabled');
        $('.vm_btn_nextSlide', this.mc).removeClass('vm_btn_disabled');
    } else {
        $('.vm_btn_previousSlide', this.mc).removeClass('vm_btn_disabled');
        $('.vm_btn_nextSlide', this.mc).addClass('vm_btn_disabled');
    }
}
VCASMOPlayer.prototype.swapSlide = function(oldno, newno) {
    var slides = $('.vm_slide_holder img', this.mc);
    if (this.traneffect == 'fade') {
        slides.eq(oldno).fadeOut(500);
        slides.eq(newno).fadeIn(500);
    	$('.vm_slide_holder #map_'+oldno, this.mc).fadeOut(500);
    	$('.vm_slide_holder #map_'+newno, this.mc).fadeIn(500);
    } else {
        slides.eq(oldno).hide();
        slides.eq(newno).show();
    	$('.vm_slide_holder #map_'+oldno, this.mc).hide();
    	$('.vm_slide_holder #map_'+newno, this.mc).show();
    }
}
VCASMOPlayer.prototype.setSlideno = function(slideno) {
    $('.vm_slideno_current', this.mc).text(slideno + 1);
}
VCASMOPlayer.prototype.emailFriend = function() {
    // BUG: not support double-byte character in emailContent when arrive email client (desktop only, no problem in mobile)
    window.location.href = 'mailto:?subject=' + this.emailSubject + '&body=' + this.emailContent + escape(String.fromCharCode(10) + String.fromCharCode(13)) + this.emailLink;
}
VCASMOPlayer.prototype.showHideVideoInfoBtn = function(showPlayBtn) {
    if (!showPlayBtn) {
        $('.vm_btn_play', this.mc).hide();
        $('.vm_btn_pause', this.mc).show();
    } else {
        $('.vm_btn_play', this.mc).show();
        $('.vm_btn_pause', this.mc).hide();
    }
}
VCASMOPlayer.prototype.showHideDualThumbnailPanel = function() {
    var self = this;
    var btn = $('.vm_thumbnal_btn', this.mc);
    var thumb = $('.vm_dualscreen_thumbnail', this.mc);
    var thumb_bg = $('.vm_thumbnail_bg', thumb);
    var thumb_holder = $('.vm_thumbnail_holder', thumb);
    var thumb_panel = $('.vm_thumbnail_panel', thumb);
    if (btn.hasClass('vm_thumbnal_show_btn')) {
        btn.removeClass('vm_thumbnal_show_btn');
        btn.addClass('vm_thumbnal_hide_btn');
        thumb.css('right', '0');
        thumb_bg.show();
        thumb_holder.show();
        thumb_panel.animate({
            'right' : Math.abs(thumb_panel.parent().cssNo('right'))
        }, 200, function() {
            self.showHideThumbScrollBar(true);
        });
    } else {
        this.thumbScroll.stop();
        this.lastThumbScrollPos = (this.isThumbScrollVertical) ? this.thumbScroll.y : this.thumbScroll.x;
        thumb_panel.animate({
            'right' : btn.attr('oldRight')
        }, 200, function() {
            btn.removeClass('vm_thumbnal_hide_btn');
            btn.addClass('vm_thumbnal_show_btn');
            thumb.css('right', thumb.attr('oldRight'));
            thumb_bg.hide();
            thumb_holder.hide();
            self.showHideThumbScrollBar(false);
        });
    }
}
VCASMOPlayer.prototype.showHideThumbScrollBar = function(bool) {
    if (!this.isThumbScrollInited) {
        var thumb_holder = (!this.vo.vcasmo_full) ? $('.vm_dualscreen_thumbnail .vm_thumbnail_holder', this.mc) : $('.vm_thumbnail .vm_thumbnail_holder', this.mc);
        this.thumbScroll = thumb_holder.parent().iscroll({hScroll:!this.isThumbScrollVertical,vScrollbar:this.isThumbScrollVertical});
        this.isThumbScrollInited = true;

    }
    var self = this
    setTimeout(function(){
        if (self.isResized) {
            self.isResized = false;
            self.thumbScroll.refresh();
        } else {
        }
        self.tbMoveToLastPosition(0);
    }, 0);
}
VCASMOPlayer.prototype.tbMoveToLastPosition = function(speed) {
    if (this.isThumbScrollVertical) {
        this.thumbScroll.scrollTo(0, this.lastThumbScrollPos, speed);
    } else {
        this.thumbScroll.scrollTo(this.lastThumbScrollPos,0, speed);
    }
}
VCASMOPlayer.prototype.tbMoveTo = function(sno) {
    var pos = Math.min(this.maxThumbScrollRange, this.thumbUnitSize*sno);
    this.lastThumbScrollPos = -pos;
    if (this.isThumbScrollInited) {    
        this.tbMoveToLastPosition(500);
    }
}
VCASMOPlayer.prototype.resizeScroller = function() {
    if (this.isThumbScrollInited) {
        var btn = $('.vm_thumbnal_btn', this.mc);
        if (btn.addClass('vm_thumbnal_show_btn')) {
            this.thumbScroll.refresh();
            this.tbMoveToLastPosition(0);
        }
    }
    var thumb_holder = (!this.vo.vcasmo_full) ? $('.vm_dualscreen_thumbnail .vm_thumbnail_holder', this.mc) : $('.vm_thumbnail .vm_thumbnail_holder', this.mc);
    if (this.isThumbScrollVertical) {
        this.maxThumbScrollRange = Math.max(0, thumb_holder.height()-thumb_holder.parent().height());
    } else {
        this.maxThumbScrollRange = Math.max(0, thumb_holder.width()-thumb_holder.parent().width());
    }
}
VCASMOPlayer.prototype.showHideBtn = function(btn, bool) {
    if (bool) {
        $(btn, this.mc).removeClass('vm_btn_disabled');
    } else {
        $(btn, this.mc).addClass('vm_btn_disabled');
    }
}
VCASMOPlayer.prototype.showHidePrintButton = function() {
    $('.vm_btn_printAll', this.mc).toggle();
    $('.vm_btn_printCurrent', this.mc).toggle();
}
VCASMOPlayer.prototype.slidePrint = function() {
    var paper = $('.vm_paper', this.mc);
    paper.empty();
    var slide_holder = $('.vm_slide_holder img', this.mc);
    var img = slide_holder.eq(this.slide_current).clone();
    img.removeClass('vm_slide_image');
    img.width('auto');
    img.height('auto');
    paper.append(img);
    this.showHidePrintButton();
    print();
}
VCASMOPlayer.prototype.slidePrintAll = function() {
    var paper = $('.vm_paper', this.mc);
    paper.empty();
    var img = $('.vm_thumbnail_holder img', this.mc).clone();
    img.removeClass('vm_slide_image');
    
    // TODO: make IE can print multiple pages
    //img.css('display','block');
    
    img.width('auto');
    img.height('auto');
    paper.append(img);
    this.showHidePrintButton();
    print();
}
VCASMOPlayer.prototype.showMsg = function(str) {
    if (str) {
        $('.vm_error_msg_holder', this.mc).css('display', 'table');
        $('.vm_error_msg_text', this.mc).text(str);
    } else {
        $('.vm_error_msg_holder', this.mc).hide();
    }
}
VCASMOPlayer.prototype.slideSequenceStop = function() {
    this.netStreamOnStatus('pause');
}
VCASMOPlayer.prototype.slideLoaded = function(img, isSlide) {
    if (img.attr('src') == this.indicator)
        return false;
    img.css('width', 'auto');
    img.css('height', 'auto');
    this.imgRealSize(img);
    /*var ow = img.prop('naturalWidth');
    var oh = img.prop('naturalHeight');*/
    /*if (ow==0 || oh==0) {
        img.hide();
        setTimeout(function(){
            self.slideLoaded(img, isSlide)
        }, 500);
        return false;
    }*/
    /*img.attr('oldW', ow);
    img.attr('oldH', oh);*/
    var holder = img.parent();
    var hw = holder.width();
    var hh = holder.height();
    if (isSlide) {
    	var sno = img.attr('slideno');
    }
    this.imageResize(img, hw, hh, true);
}
VCASMOPlayer.prototype.imgRealSize = function(img) {
    if (img.prop('naturalWidth') === undefined) {
        var tmpImg = $('<img/>').attr('src', img.attr('src'));
        img.prop('naturalWidth', tmpImg[0].width);
        img.prop('naturalHeight', tmpImg[0].height);
    }
    return {
        'width': img.prop('naturalWidth'),
        'height': img.prop('naturalHeight')
    };
}
VCASMOPlayer.prototype.imageResize = function(img, hw, hh, isSlide) {
    if (img.attr('src') == this.indicator)
        return false;
    var iw = img.prop('naturalWidth');
    var ih = img.prop('naturalHeight');
    if (!iw || !ih)
        return false;
    //this.imageResizeFitAs(img, ((iw > ih) && (hw < hh)), isSlide);
    this.imageResizeFitAs(img, ((iw / ih) > (hw / hh)), isSlide);
    if (img.width() > hw) {
        this.imageResizeFitAs(img, true);
    }
}
VCASMOPlayer.prototype.imageResizeFitAs = function(img, isFitAsWidth, isSlide) {
    if (isFitAsWidth) {
        img.css('width', '100%');
        img.css('height', 'auto');
    } else {
        img.css('width', 'auto');
        img.css('height', '100%');
    }
}
VCASMOPlayer.prototype.dispatchEvent = function(msgStr, obj) {
	if (this.vo.extjs==1) {
        this.windowProxy.post([msgStr, obj]);
		/*try {
			parent[msgStr](obj);
		} catch (error) {
			try {
				window[msgStr](obj);	
			} catch (error) {
				try {
					top[msgStr](obj);	
				} catch (error) {
					
				}
			}
		}*/
	}
}
VCASMOPlayer.prototype.secToHMS = function(n) {
    n = parseInt(n);
    var hr = Math.floor(n / 3600);
    var min = n % 3600;
    var sec = min % 60;
    min = Math.floor(min / 60);
    return this.NumberToDoubleNumber(hr) + ":" + this.NumberToDoubleNumber(min) + ":" + this.NumberToDoubleNumber(sec);
}
VCASMOPlayer.prototype.NumberToDoubleNumber = function(n) {
    n = Number(n);
    if (n < 10) {
        n = "0" + n;
    }
    return n;
}
VCASMOPlayer.prototype.errorExit = function(str) {
    var self = this;
    setTimeout(function() {
        self.dispatchEvent('vcasmoStop', {error:true,errorMsg:str,sec:self.duration_total});
    }, 3000);
}